{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainUnit;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL, KOLSPCDriveComboBox, KOLSPCDirectoryListBox, KOLSPCFileListBox, KOLSPCFilterComboBox {$IFNDEF KOL_MCK}, mirror, Classes,  mckObjs,  mckSPCFileListBox, mckCtrls, mckSPCDirectoryListBox, Controls,  mckSPCDriveComboBox,  mckSPCFilterComboBox {$ENDIF};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mirror;
{$ENDIF}

type

  TBMPPalette=array[0..255]of record
                                 B,G,R,F: Byte;
                               end;

  TFileType=(ftPCX,ftBMP,ftNone);

  TPCXFormat=(pcx8bit,pcx24bit);

  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    MainMenu1: TKOLMainMenu;
    Panel1: TKOLPanel;
    SPCDriveComboBox1: TSPCDriveComboBox;
    SPCDirectoryListBox1: TSPCDirectoryListBox;
    SPCFileListBox1: TSPCFileListBox;
    SPCFilterComboBox1: TSPCFilterComboBox;
    GroupBox1: TKOLGroupBox;
    GroupBox2: TKOLGroupBox;
    ScrollBox1: TKOLScrollBox;
    Label1: TKOLLabel;
    Label3: TKOLLabel;
    Label4: TKOLLabel;
    PaintBox1: TKOLPaintBox;
    Label5: TKOLLabel;
    Label6: TKOLLabel;
    Label7: TKOLLabel;
    Label8: TKOLLabel;
    GroupBox3: TKOLGroupBox;
    Button1: TKOLButton;
    Timer1: TKOLTimer;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    OpenSaveDialog2: TKOLOpenSaveDialog;
    Button3: TKOLButton;
    Label10: TKOLLabel;
    Label2: TKOLLabel;
    GroupBox4: TKOLGroupBox;
    Label9: TKOLLabel;
    Label11: TKOLLabel;
    KOLApplet1: TKOLApplet;
    procedure KOLForm1N3Menu(Sender: PMenu; Item: Integer);
    procedure SPCDriveComboBox1Change(Sender: PObj);
    procedure SPCFilterComboBox1Change(Sender: PObj);
    procedure KOLForm1Show(Sender: PObj);
    procedure SPCDirectoryListBox1Change(Sender: PObj);
    procedure SPCFileListBox1SelChange(Sender: PObj);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure Timer1Timer(Sender: PObj);
    procedure Button3Click(Sender: PObj);
    procedure PaintBox1Click(Sender: PObj);
    procedure Button1Click(Sender: PObj);
    procedure KOLForm1N1Menu(Sender: PMenu; Item: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function DetectFileType(Value: string): TFileType;
  function GetLastPos(c: char; s: string): Integer;
  function LoadPCX(Value: string): Boolean;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  CurDir: string;
  FTemp,FOut: PStream;
  BufferBitmap: PBitmap;
  BMPPalette: TBMPPalette;
  Buffer: array[0..1023]of char;
  id: array[1..2]of char;
  BMPHeader: record
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;
               DataSize2: LongInt;
               _C5: array[1..8]of Byte;
             end;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses About;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainUnit_1.inc}
{$ENDIF}

procedure TForm1.KOLForm1N3Menu(Sender: PMenu; Item: Integer);
begin
  Form.Close;
end;

procedure TForm1.SPCDriveComboBox1Change(Sender: PObj);
begin
  SPCDirectoryListBox1.Path:=SPCDriveComboBox1.Drive+':';
end;

procedure TForm1.SPCFilterComboBox1Change(Sender: PObj);
begin
  SPCFileListBox1.Mask:=SPCFilterComboBox1.Filter;
end;

procedure TForm1.KOLForm1Show(Sender: PObj);
begin
  id[1]:='B';
  id[2]:='M';
  GetDir(0,CurDir);
  SPCDriveComboBox1.Drive:=CurDir[1];
  SPCDirectoryListBox1.Path:=CurDir;
  GroupBox1.Visible:=True;
  GroupBox2.Visible:=False;
  BufferBitmap:=NewBitmap(0,0);
end;

procedure TForm1.SPCDirectoryListBox1Change(Sender: PObj);
begin
  SPCFileListBox1.Path:=SPCDirectoryListBox1.Path;
end;

procedure TForm1.SPCFileListBox1SelChange(Sender: PObj);
var
  fType: TFileType;
begin
  fType:=DetectFileType(SPCFileListBox1.Path+'\'+SPCFileListBox1.GetFileName);
  Timer1.Enabled:=False;
  case fType of
  ftPCX: begin
           if LoadPCX(SPCFileListBox1.Path+'\'+SPCFileListBox1.GetFileName) then
           begin
             GroupBox2.Visible:=False;
             GroupBox1.Visible:=True;
             PaintBox1.OnPaint(@Self,PaintBox1.Handle);
             Label3.Caption:=Int2Str(BufferBitmap.Width)+'x'+Int2Str(BufferBitmap.Height);
             case BufferBitmap.PixelFormat of
               pf8bit: Label4.Caption:='8 bit';
               pf24bit: Label4.Caption:='24 bit';
               else Label4.Caption:='<>';
             end;
           end else ShowMessage(' !');
         end;
  ftBMP: begin
           GroupBox1.Visible:=False;
           GroupBox2.Visible:=True;
           BufferBitmap.LoadFromFileEx(SPCFileListBox1.GetFileName);
           Label7.Caption:=Int2Str(BufferBitmap.Width)+'x'+Int2Str(BufferBitmap.Height);
           case BufferBitmap.PixelFormat of
             pf1bit: Label8.Caption:='1 bit';
             pf4bit: Label8.Caption:='4 bit';
             pf8bit: Label8.Caption:='8 bit';
             pf15bit: Label8.Caption:='15 bit';
             pf16bit: Label8.Caption:='16 bit';
             pf24bit: Label8.Caption:='24 bit';
             pf32bit: Label8.Caption:='32 bit';
             else Label8.Caption:='<>';
           end;
           PaintBox1.OnPaint(@Self,PaintBox1.Handle);
         end;
  end;
  Timer1.Enabled:=True;
end;

function DetectFileType(Value: string): TFileType;
var
  Ext: string;
begin
  Ext:=Copy(Value,GetLastPos('.',Value)+1,Length(Value)-GetLastPos('.',Value));
  if UpperCase(Ext)='PCX' then Result:=ftPCX else
  if UpperCase(Ext)='BMP' then Result:=ftBMP else
  Result:=ftNone;
end;

function GetLastPos(c: char; s: string): Integer;
var
  i,Index: Integer;
begin
  Index:=0;
  for i:=1 to Length(s) do if s[i]=c then Index:=i;
  Result:=Index;
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
begin
  PaintBox1.Width:=BufferBitmap.Width;
  PaintBox1.Height:=BufferBitmap.Height;
  BufferBitmap.Draw(PaintBox1.Canvas.Handle,0,0);
end;

function LoadPCX(Value: string): Boolean;
var
  FPcx: PStream;
  Check1,Check2: Boolean;
  fSize,MaxX,MaxY,i,y: LongInt;
  PFileType: TPCXFormat;
  Add: Byte;
begin
  Result:=True;
  if not FileExists(Value) then
  begin
    Result:=False;
    Exit;
  end;
  FPcx:=NewReadFileStream(Value);
  FPcx.Read(fSize,4);
  FPcx.Read(MaxX,4);
  FPcx.Read(MaxY,4);
  if fSize=(MaxX*MaxY*3) then Check1:=True else Check1:=False;
  if fSize=(MaxX*MaxY) then Check2:=True else Check2:=False;
  if Check1 then PFileType:=pcx24bit else
  if Check2 then PFileType:=pcx8bit else
  begin
    FPcx.Free;
    Result:=False;
    Exit;
  end;
  BMPHeader.X:=MaxX;
  BMPHeader.Y:=MaxY;
  Add:=Round(Int((4*(1-(Frac(MaxX/4))))));
  if Add=4 then Add:=0;
  case PFileType of
   pcx8bit:begin
             with BMPHeader do
             begin
               _C1:=$00000436;
               _C2:=$00000028;
               _C3:=$0001;
               _C4:=$0008;
               DataSize1:=MaxX*MaxY;
               DataSize2:=MaxX*MaxY;
               FullSize:=DataSize1+$436;
             end;
           end;
   pcx24bit:begin
              with BMPHeader do
              begin
                _C1:=$00000036;
                _C2:=$00000028;
                _C3:=$0001;
                _C4:=$0018;
                DataSize1:=$0B12;
                DataSize2:=$0B12;
                FullSize:=((MaxX+Add)*MaxY)*3+$36;
              end;
            end;
  end;
  IF PFileType=pcx8bit THEN
  BEGIN
    FPcx.Seek(FPcx.Size-256*3,spBegin);
    for i:=0 to 255 do
    begin
      FPcx.Read(BMPPalette[i].R,1);
      FPcx.Read(BMPPalette[i].G,1);
      FPcx.Read(BMPPalette[i].B,1);
      BMPPalette[i].F:=0;
    end;
  END;
  FTemp:=NewMemoryStream;
  FTemp.Write(ID,2);
  FTemp.Write(BMPHeader,SizeOf(BMPHeader));
  if PFileType=pcx8bit then
  begin
    FTemp.Write(BMPPalette,SizeOf(BMPPalette));
    for y:=MaxY downto 1 do
    begin
      FPcx.Seek($0C+(y-1)*MaxX,spBegin);
      Stream2Stream(FTemp,FPcx,MaxX);
      if Add>0 then FTemp.Write(Buffer,Add);
    end;
  end;
  if PFileType=pcx24bit then
  for y:=MaxY downto 1 do
  begin
    FPcx.Seek($0C+(y-1)*(MaxX*3),spBegin);
    Stream2Stream(FTemp,FPcx,MaxX*3);
    if Add>0 then FTemp.Write(Buffer,Add*3);
  end;
  FTemp.Seek(0,spBegin);
  BufferBitmap.LoadFromStream(FTemp);
  FTemp.Free;
  Result:=True;
end;

procedure TForm1.Timer1Timer(Sender: PObj);
var
  fPixelFormat: TPixelFormat;
begin
  fPixelFormat:=BufferBitmap.PixelFormat;
  if fPixelFormat=pf8bit then
  begin
    Button1.Enabled:=True;
    Button3.Enabled:=False;
    if not (Label10.Caption='   ') then
    begin
      Label10.Caption:='   ';
      Label10.Font.Color:=clGreen;
    end;
  end else
  begin
    Button1.Enabled:=False;
    Button3.Enabled:=True;
    if not (Label10.Caption='    8- ') then
    begin
      Label10.Caption:='    8- ';
      Label10.Font.Color:=clRed;
    end;
  end;
  if (fPixelFormat=pf15bit)or(fPixelFormat=pf16bit)or(fPixelFormat=pf24bit)or(fPixelFormat=pf32bit)then GroupBox4.Visible:=True else GroupBox4.Visible:=False;
end;

procedure TForm1.Button3Click(Sender: PObj);
begin
  BufferBitmap.PixelFormat:=pf8bit;
  PaintBox1.OnPaint(@Self,PaintBox1.Handle);
  Label7.Caption:=Int2Str(BufferBitmap.Width)+'x'+Int2Str(BufferBitmap.Height);
  case BufferBitmap.PixelFormat of
    pf8bit: Label8.Caption:='8 bit';
  else Label8.Caption:='<>';
  end;
end;

procedure TForm1.PaintBox1Click(Sender: PObj);
begin
  OpenSaveDialog1.FileName:=CurDir+'\'+Copy(SPCFileListBox1.GetFileName,1,GetLastPos('.',SPCFileListBox1.GetFileName)-1);
  if OpenSaveDialog1.Execute then
  begin
    BufferBitmap.SaveToFile(OpenSaveDialog1.FileName);
    CurDir:=ExtractFilePath(OpenSaveDialog1.FileName);
    Delete(CurDir,Length(CurDir),1);
    SPCFileListBox1.Path:=SPCFileListBox1.Path;
  end;
end;

procedure TForm1.Button1Click(Sender: PObj);
var
  fColors: LongInt;
  fDataSize,fWidth,fHeight,i: LongInt;
  Add: Byte;
begin
  OpenSaveDialog2.FileName:=CurDir+'\'+Copy(SPCFileListBox1.GetFileName,1,GetLastPos('.',SPCFileListBox1.GetFileName)-1);
  if not OpenSaveDialog2.Execute then Exit;
  FTemp:=NewMemoryStream;
  fWidth:=BufferBitmap.Width;
  fHeight:=BufferBitmap.Height;
  fDataSize:=fWidth*fHeight;
  BufferBitmap.SaveToStream(FTemp);
  FTemp.Seek($36,spBegin);
  for i:=0 to 255 do
  begin
    FTemp.Read(BMPPalette[i].R,1);
    FTemp.Read(BMPPalette[i].G,1);
    FTemp.Read(BMPPalette[i].B,1);
    FTemp.Read(BMPPalette[i].F,1);
  end;
  Add:=Round(Int((4*(1-(Frac(fWidth/4))))));
  if Add=4 then Add:=0;
  FOut:=NewWriteFileStream(OpenSaveDialog2.FileName);
  FOut.Write(fDataSize,4);
  FOut.Write(fWidth,4);
  FOut.Write(fHeight,4);
  for i:=1 to fHeight do
  begin
    FTemp.Seek($0436+(fHeight-i)*(fWidth+Add),spBegin);
    Stream2Stream(FOut,FTemp,fWidth);
  end;
  for i:=0 to 255 do
  begin
    FOut.Write(BMPPalette[i].B,1);
    FOut.Write(BMPPalette[i].G,1);
    FOut.Write(BMPPalette[i].R,1);
  end;
  FOut.Free;
  FTemp.Free;
  CurDir:=ExtractFilePath(OpenSaveDialog2.FileName);
  Delete(CurDir,Length(CurDir),1);
end;

procedure TForm1.KOLForm1N1Menu(Sender: PMenu; Item: Integer);
begin
  Form2.Form.ShowModal;
  Form2.Form.Hide;
end;

end.
